/**************************************************************************************
* CFMove - a program that moves/copies files inside of the CF card
* of a TRGpro
* Copyright (C) 2001 by Enno Welbers
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or 
* (at your opinion) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program, see LICENSE.txt; if not, write to the Free
* Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  0211-1307  USA
*
* You can contact the author via: mkernel@users.sourceforge.net or enno_welbers@gmx.de
**************************************************************************************/
#ifndef CFMOVE_H__
#define CFMOVE_H__

#include <PalmOS.h>
#include <TRG/ffslib.h>
#define PalmOS
#include <gengine.h>

typedef struct {
  char *name;
  MemHandle hndname;
  bool isdir;
} dircontent;

#define SRC 1
#define DEST 2

//core.c
extern UInt16 FfsLibRef;
extern char *src, *dest;
extern cldata client;
extern int state;

//ffsmgr.c
extern int dircontentmax;
extern dircontent *DirContent;
extern MemHandle DirContentHandle;
//ui.c
extern char *acttitle;

//core.c
void Core(int mvcp);
bool InitLibs(void);
void DeInitLibs(void);
UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 Launchflags);
void fillsrc(int chosen);
int newfile(char *srcfn);
void playsnd(void);
void playsnd2(void);
void shutdown(bool srcb, bool destb, bool freeDirContent, bool deinitlibs);

//ffsmgr.c
void MoveRoot(void);
void processDir(void);
void freeprocessvars(void);
void SwitchtoDir(int id); 
int newdir(void);
//ui.c
void title(char *Title);
int UIDirContent(void);
int MvCpCa(void);

#endif