/**************************************************************************************
* CFMove - a program that moves/copies files inside of the CF card
* of a TRGpro
* Copyright (C) 2001 by Enno Welbers
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or 
* (at your opinion) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program, see LICENSE.txt; if not, write to the Free
* Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  0211-1307  USA
*
* You can contact the author via: mkernel@users.sourceforge.net or enno_welbers@gmx.de
**************************************************************************************/
#include "cfmove.h"

int dircontentmax=0;
dircontent *DirContent;
MemHandle DirContentHandle;

void MoveRoot(void)
{
  char *cwd;
  cwd=FfsGetcwd(FfsLibRef,NULL,1024);
  if(StrCompare(cwd,"\\")!=0)
    FfsChdir(FfsLibRef,"\\");
  MemPtrFree(cwd);
}

int newdir(void)
{
  int length=1,size=1,lastpos=-1;
  char *fn;
  MemHandle fnH;
  event Event;
  coordinates point;
  FieldType *Field;
  void *FormP;
  FormType *FormP2;

  FormP=client.Form;
  fnH=MemHandleNew(257);
  fn=MemHandleLock(fnH);
  fn[0]='\0';
  MemHandleUnlock(fnH);
  Field=FldNewField(&FormP,1001,30,40,100,12,stdFont,256,true,true,true,false,leftAlign,false,false,false);
  client.Form=FormP;
  FldSetText(Field,fnH,0,257);
  FldDrawField(Field);
  FrmSetFocus(client.Form,FrmGetObjectIndex(client.Form,1001));  
  point.x=42;point.y=119;
  drawtext(&client,1,point,false,0,"1");
  point.y=142;
  drawtext(&client,1,point,false,0,"2");
  point.x=80;
  point.y=113;
  drawtext(&client,1,point,false,0,"1: OK");
  point.y=123;
  drawtext(&client,1,point,false,0,"2: CANCEL");
  title("Enter Directoryname");
  while(1==1)
    {
      Event.type=0;
      getevent(&client,&Event);
      if(client.OSEvent.screenY<52|client.OSEvent.eType!=penDownEvent)
      FldHandleEvent(Field,&client.OSEvent);
      if(Event.type==EventAppStopEvent)
      {
        MemHandleFree(fnH);
        FormP2=client.Form;
        FldEraseField(Field);
        FrmRemoveObject(&FormP2,FrmGetObjectIndex(FormP,1001));
        client.Form=FormP2;
        return -1;
      }
      else if(Event.type==EventMouseButtonPressEvent)
        {
          if(Event.ebtn.x>42 && Event.ebtn.y>113 && Event.ebtn.y<130 && Event.ebtn.x<58)
            break;
          else if(Event.ebtn.x>42 && Event.ebtn.y>140 && Event.ebtn.y<158 && Event.ebtn.x<58)
            {
              MemHandleFree(fnH);
              FldEraseField(Field);
              FormP2=client.Form;
              FrmRemoveObject(&FormP2,FrmGetObjectIndex(FormP,1001));
              client.Form=FormP2;
              return -1;
            }
        }
    }
  point.x=42;point.y=119;
  removetext(&client,point,false,"1");
  point.y=142;
  removetext(&client,point,false,"2");
  point.x=80;
  point.y=113;
  removetext(&client,point,false,"1: OK");
  point.y=123;
  removetext(&client,point,false,"2: CANCEL");
  fnH=FldGetTextHandle(Field);
  fn=MemHandleLock(fnH);
  FfsMkdir(FfsLibRef,fn);
  FfsChdir(FfsLibRef,fn);
  MemHandleUnlock(fnH);
  MemHandleFree(fnH);
  FldEraseField(Field);
  FormP2=client.Form;
  FrmRemoveObject(&FormP2,FrmGetObjectIndex(FormP,1001));
  client.Form=FormP2;
  return 0;
}

void processDir(void)
{
  ffblk Search;
  char tst;
  int processed=1,count;
  DirContentHandle=MemHandleNew(sizeof(dircontent)*processed);
  DirContent=MemHandleLock(DirContentHandle);
  FfsFindfirst(FfsLibRef,"*.*",FA_ALL,&Search);
  if(StrLen(Search.ff_longname)==0)
    {
      DirContent[dircontentmax].hndname=MemHandleNew(13);
      DirContent[dircontentmax].name=MemHandleLock(DirContent[dircontentmax].hndname);
      count=0;
      while(Search.ff_name[count]!='\0')
        {
          DirContent[dircontentmax].name[count]=Search.ff_name[count];
          count++;
        }
      DirContent[dircontentmax].name[count]='\0';
    }
  else
    {
      DirContent[dircontentmax].hndname=MemHandleNew(256);
      DirContent[dircontentmax].name=MemHandleLock(DirContent[dircontentmax].hndname);
      count=0;
      while(Search.ff_longname[count]!='\0')
        {
          DirContent[dircontentmax].name[count]=Search.ff_longname[count];
          count++;
        }
      DirContent[dircontentmax].name[count]='\0';
    }
  tst=Search.ff_attrib&FA_DIREC;
  if(tst==FA_DIREC)
    DirContent[dircontentmax].isdir=true;
  else
    DirContent[dircontentmax].isdir=false;
  processed++;
  while(1==1)
    {
      if(FfsFindnext(FfsLibRef,&Search)==-1)
        break;
      MemHandleUnlock(DirContentHandle);
      MemHandleResize(DirContentHandle,sizeof(dircontent)*processed);
      DirContent=MemHandleLock(DirContentHandle);
      dircontentmax++;
      if(StrLen(Search.ff_longname)==0)
        {
          DirContent[dircontentmax].hndname=MemHandleNew(13);
          DirContent[dircontentmax].name=MemHandleLock(DirContent[dircontentmax].hndname);
          count=0;
          while(Search.ff_name[count]!='\0')
            {
              DirContent[dircontentmax].name[count]=Search.ff_name[count];
              count++;
            }
          DirContent[dircontentmax].name[count]='\0';
        }
      else
        {
          DirContent[dircontentmax].hndname=MemHandleNew(256);
          DirContent[dircontentmax].name=MemHandleLock(DirContent[dircontentmax].hndname);
          count=0;
          while(Search.ff_longname[count]!='\0')
            {
              DirContent[dircontentmax].name[count]=Search.ff_longname[count];
              count++;
            }
          DirContent[dircontentmax].name[count]='\0';
        }
      tst=Search.ff_attrib&FA_DIREC;
      if(tst==FA_DIREC)
        DirContent[dircontentmax].isdir=true;
      else
        DirContent[dircontentmax].isdir=false;
      processed++;
    }
  FfsFinddone(FfsLibRef,&Search);
}

void freeprocessvars(void)
{
  int count;
  for(count=0;count!=dircontentmax;count++)
    {
      MemHandleUnlock(DirContent[count].hndname);
      MemHandleFree(DirContent[count].hndname);
    }
  MemHandleUnlock(DirContentHandle);
  MemHandleFree(DirContentHandle);
  dircontentmax=0;
}

void SwitchtoDir(int id)
{
  FfsChdir(FfsLibRef,DirContent[id].name);
}
